/* n2dot.js   (nexus to dot)
   n2dot converts a phylip treefile (or any file in newick format) to
   a .dot file for use with the graph drawing programs neato, dot...

   (c) 2004 Jean-Paul Davalan <jpdvl@wanadoo.fr>

   n2dot is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   n2dot is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with n2dot; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   http://perso.wanadoo.fr/jean-paul.davalan/graphs/index.html

 */

var textpar, treepar, treedot;

var textbase ="";

var textsample = "(finWhale:0.42666,(((human:0.43389,chimpanzee:0.43101):0.04639,\n"
+"(rat:0.46971,mouse:0.47194):0.01189):0.00090,(horse:0.47057,\n"
+"((harborSeal:0.38648,graySeal:0.38734):0.08492,cat:0.47143)\n"
+":0.00752):0.00174):0.04955,blueWhale:0.42780);";

function efface() {
  document.fr1.treein.value=textbase;
}
function exemple() {
  document.fr1.treein.value=textsample;
}


function tree() {
  
  var textpar, treepar;
  var treedot='/*  ----------------------------------------- \n'
  +'     Nom du graphe ou\n'
  +'     commentaires...\n'
  +'  ----------------------------------------- */\n'
  +'graph Grrrr {\n' 
  +'  size=\"7,10\"; // inches\n'
  +'  ratio=1.4; // h/w\n'
  +'  node [fontsize=24];\n';
  
  this.textpar=textpar
  this.treepar=treepar;
  this.treedot=treedot;
//  this.tab = new Array();
  
  function lit() {
//    alert("lit");
    this.textpar = document.fr1.treein.value;
    var s;
    var a = this.textpar.split(/\n*-{20,200}/);
    this.treepar =  a[0];
  
    this.treepar = this.treepar.replace(/\s*\n+/g,"");
//    this.treepar = this.treepar.replace(/\s+/g,"");
    
    //alert(this.treepar);
  }
  this.lit=lit;
  
  function convertit() {
//  alert("convertit");
    var tab = new Array();
    var n=0;
    var s2, bs,s = this.treepar;
    var drp = (document.fr1.rd[0].checked == true)
    var pattern1 = /^(\(\s*)/, pattern2 = /(\)\s*)$/
    while((s.match(/\([^\(\)]*\)/))!=void(0)) {
      s2 = ""+s.match(/\([^\(\)]*\)/);
      s = s.replace(/\([^\(\)]*\)/,"n"+n);
      s2 = s2.replace(pattern1,"");
      s2 = s2.replace(pattern2,"");
      tab[n] = s2;
      n++
    }
    for(i=0;i<n;i++) {
      this.treedot = this.treedot+"  n"+i+"  [shape=plaintext,fontsize=16];\n"
    }
    for(i=0;i<n;i++) {
//       var b = this.tab[i].split(",")
        var b = tab[i].split(",")
       for(k=0;k<b.length;k++) {
         var c = b[k].split(":");
	 this.treedot = this.treedot + "  n" + i + " -- "
	 if(c[0].replace(/s+/g, "" ) == "") {
	   c[0]="\"" + c[0] + "\""
	 }

	 if( c[0]==void(0) ) {
           c[0]= '\"\"';
	 }
	 if(c[0].match(/_/g) != void(0) || c[0].match(/\s /g)!=void(0)) {
	   var s="";
	   while(s!=c[0]) {
	   s = c[0];
	   c[0] = s.replace(/_/g," ");
	   }
	   this.treedot = this.treedot+ "\""+ c[0].replace(/_/g," ")+"\"";
	 } else {
	   this.treedot = this.treedot+ c[0]
	 }
	 if(drp==true && c[1]!=void(0)) {
	   c[1] = c[1].replace(/^\s+/,"");
	   c[1] = c[1].replace(/\s+$/,"");
	   if(c[1]!=void(0) && c[1]!=""){
	      var s="";
	      while(s!=c[1]) {
	        s = c[1];
	        c[1] = s.replace(/_/g," ");
	      }
	     this.treedot = this.treedot+ " [label=\""+c[1]+"\",fontsize=12];"
	   }
	 }
         this.treedot = this.treedot + "\n"
       }
    }
    this.treedot = this.treedot+'}\n';
//    alert(this.treedot);
  }
  this.convertit=convertit;
  
  function ecrit() {
//    alert("ecrit");
    document.fr2.treeout.value =  this.treedot;
  }
  this.ecrit=ecrit;
  
  function todot() {
     this.lit();
     this.convertit();
     this.ecrit();
  }
  this.todot=todot;
}

function cherche() {
  var tr=new tree();
  tr.lit();
  tr.convertit();
  tr.ecrit();
//  tr.todot();
}

